﻿using System;
using System.ComponentModel.Composition;
using System.ComponentModel.Composition.Hosting;
using System.Reflection;

namespace Usando_MEF
{
    class Program
    {
        [Import]
        public string Mensagem { get; set; }

        public class Apresentacao
        {
            [Export]
            public String Mensagem
            {
                get
                {
                    return "Apresentando MEF";
                }
            }
        }

        public void Run()
        {
            //Apresentacao ap = new Apresentacao();
            //Mensagem = ap.Mensagem;

            //var catalog = new AttributedAssemblyPartCatalog(Assembly.GetExecutingAssembly());
            //var container = new CompositionContainer(catalog.CreateResolver());
            var catalog = new AssemblyCatalog(Assembly.GetExecutingAssembly());
            var container = new CompositionContainer(catalog);
            //An aggregate catalog that combines multiple catalogs
            //var catalog = new AggregateCatalog();
            //var catalog = new AssemblyCatalog(Assembly.GetExecutingAssembly());
            //var container = new CompositionContainer(catalog);
            //Adds all the parts found in the same assembly as the Program class
            //catalog.Catalogs.Add(new AssemblyCatalog(typeof(Program).Assembly));
            var batch = new CompositionBatch();
            batch.AddPart(this);
            container.Compose(batch);

            Console.WriteLine(Mensagem);
            Console.ReadKey();
        }

        static void Main(string[] args)
        {
            Program p = new Program();
            p.Run();
        }
    }
}
